import os
import os.path
import subprocess 
import sys


def hello():
    """Just say hi"""
    print "J'allo J'allo, V'erld!"


def main():

    def help():
        print ""
        print "YARGWID"
        print "This is the yargwid dotfile installation script"
        print ""
        print "This script defines actions for several existing machines."
        print "If you are on a new machine, modify the script to work for your machine." 
        print "Once you are done, run this script with the name of the machine:"
        print ""
        print "     python notquitefabfile.py maya"
        print "     python notquitefabfile.py cronus"
        print "     python notquitefabfile.py rojo"
        print "     python notquitefabfile.py morpheus"
        print "     python notquitefabfile.py basilisk"
        print "     python notquitefabfile.py jupiter"
        print ""
        print ""

    kali_machines = ['basilisk','morpheus','jupiter']
    non_kali_machines = ['rojo','cronus','maya']


    # -------------

    name = ""

    if len(sys.argv)<2 or len(sys.argv)>2:
        help()
        return 0

    else:
        machine_name = sys.argv[1]
        print "Installing dotfiles for machine ",machine_name


    # -------------

    if machine_name in kali_machines:
        print "kali machine"

        home_directory = "/root"

        print "Using root directory:",home_directory
        doit(machine_name, home_directory, am_root=True)


    elif machine_name in non_kali_machines:
        print "Non-kali machine"

	if machine_name=="maya":
            home_directory = "/Users/charles"
        elif machine_name=="cronus":
            home_directory = "/Volumes/noospace/Users/charles"
        elif machine_name=="rojo":
            home_directory = "/home/charles/"

        print "Using home directory:",home_directory
        doit(machine_name, home_directory)


    else:
        help()
        print "Unknown machine:",machine_name
        print ""





# =======================================
# do it already

def doit(machine_name,home_directory,am_root=False):

    # ------------------------------------
    # Start by defining some useful functions

    def backup(dotfile):
        if os.path.isfile(home_directory+"/."+dotfile):
            #local("mv ~/."+dotfile+" ~/."+dotfile+".backup")
            os.system("mv "+home_directory+"/."+dotfile+" "+home_directory+"/."+dotfile+".backup")
    
    
    def copy(dotfile,tempdir):
        #local("cp "+tempdir+"/"+dotfile+" ~/."+dotfile)
        os.system("cp "+tempdir+"/"+dotfile+" "+home_directory+"/."+dotfile)
    
    
    def clean(tempdir):
        #local("rm -rf "+tempdir)
        os.system("rm -rf "+tempdir)


    def done(dotfile):
        print "Finished installing file "+home_directory+"/."+dotfile
        print "(Old version is now at "+home_directory+"/."+dotfile+".backup)"
        print ""


    def make_file_from_common(dotfile,tempdir):
        """Combine the common dotfile and the machine-specific dotfile to make the final dotfile"""
    
        common_file  = "common/"+dotfile
        machine_file = machine_name+"/"+dotfile+"."+machine_name
        output_file  = tempdir+"/"+dotfile
    
        # Use the common file, or make it blank
        if os.path.isfile(common_file):
            catcmd1 = "cat "+common_file+" > "+output_file
        else:
            catcmd1 = "cat /dev/null > "+output_file
        
        # Use the machine file, or don't
        if os.path.isfile(machine_file):
            catcmd2 = "cat "+machine_file+" "+output_file+" >> tempfile && mv -f tempfile "+output_file
        else:
            print "No machine-specific",dotfile,"found for",machine_name,"- using common version."
            catcmd2 = ""
    
        # Run the commands
        os.system(catcmd1)
        os.system(catcmd2)
    

    def make_file_from_root(dotfile,tempdir):
        """Combine the root dotfile and the machine-specific dotfile to make the final dotfile"""
    
        root_file  = "root/"+dotfile
        machine_file = machine_name+"/"+dotfile+"."+machine_name
        output_file  = tempdir+"/"+dotfile
    
        # Use the root file, or make it blank
        if os.path.isfile(root_file):
            catcmd1 = "cat "+root_file+" > "+output_file
        else:
            catcmd1 = "cat /dev/null > "+output_file
        
        # Use the machine file, or don't
        if os.path.isfile(machine_file):
            catcmd2 = "cat "+machine_file+" "+output_file+" >> tempfile && mv -f tempfile "+output_file
        else:
            print "No machine-specific",dotfile,"found for",machine_name,"- using common version."
            catcmd2 = ""
    
        # Run the commands
        os.system(catcmd1)
        os.system(catcmd2)

    # --------------------------
    # Okay, just drag it out some more...
    # why don't you...


    # --------------------------
    # Start by setting up vundle
    # (make sure vimrc doesn't break)
    subprocess.call(['./scripts/setup_vundle.sh'])
    subprocess.call(['./scripts/setup_vimswap.sh'])

    tmpdir = "tmp"

    # --------------------------
    # Make temp directory
    os.system("rm -rf "+tmpdir)
    os.system("mkdir -p "+tmpdir)

    # --------------------------
    # Copy machine files
    if am_root is False:
    	mfers = ['aliases',
    	        'bash_profile',
    	        'bashrc',
    	        'emacs',
    	        'gdbinit',
    	        'gitconfig',
    	        'inputrc',
    	        'profile',
    	        'tmux.conf',
    	        'vimrc',
    	        'vimrc.bundles',
    	        'viper',
    	        'vundle.sh']
        for mf in mfers:
            make_file_from_common(mf,tmpdir)
            backup(mf)
            copy(mf,tmpdir)
            done(mf)

    else:
        # we are root
        # (kali)
        # 
        mfers = ['aliases',
                'bash_profile',
                'bashrc',
                'gitconfig',
                'inputrc',
    	        'motd',
    	        'profile',
                'vimrc',
                'vimrc.bundles',
                'viper',
                'vundle.sh']

        for mf in mfers:
            make_file_from_root(mf,tmpdir)
            backup(mf)
            copy(mf,tmpdir)
            done(mf)


    os.system("rm -rf "+tmpdir)
    os.system("cp -rf scripts "+home_directory+"/scripts")



if __name__=="__main__":
    main()

